#!/usr/bin/python

"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

import cdrom

#related excpetions:
class fstabError(Exception):
    """base class for fstab errors"""
    pass

class noFstabError(fstabError):
    """occurs when a file does not exist"""

    def __str__(self):
        return 'could not open /etc/fstab'



class fstab:
    """deals with the fstab"""

    def __init__(self):
        self.cdroms = []

        try:
            f = open('/etc/fstab')
        except IOError:
            raise noFstabError
        for line in f.readlines():
            try:
                newCdrom = cdrom.fstabCdrom(line)
                self.cdroms.append(newCdrom)
            except cdrom.notCDorDVDFstabEntryError, e:
                pass

    def getCdromList(self):
        """returns a list of the cdroms fonud in the fstab"""
        return self.cdroms


