"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

import os, gtk, p2p_diag

def drive_mounted( device ):
    fp = file( "/proc/mounts" )
    lines = fp.readlines()
    for i in lines:
        (dev, rest ) = i.split( " ", 1 )
        if dev == device:
            return 1
    return 0

class CDDialog( gtk.Dialog ):
    def __init__(self, cdroms):
        gtk.Dialog.__init__( self )
        table = gtk.Table( 2, len( cdroms ) )
        for i in range( 0, len( cdroms ) ):
           table.attach( gtk.Label( cdroms[i].getDev() ), 0, 1, i, i + 1 )
           if drive_mounted( cdroms[i].getDev() ):
               button = gtk.Button( "Unmount" )
           else:
               button = gtk.Button( "Mount" )
           button.set_name( "round_button" )
           button.connect( 'clicked', self.mount_cb, cdroms[i].getDev() )
           table.attach( button, 1, 2, i, i + 1 )
        self.get_children()[0].add( table )
        button = self.add_button( gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE )
        button.set_name( "round_button" )
        self.connect( 'response', self.response_cb )
        self.connect( 'delete-event', self.delete_cb )
        self.set_title( "Mount CDs" )
        table.show_all()

    def mount_cb( self, widget, device ):
        if drive_mounted( device ):
            (retval, message ) = mount_cd( "-u", device )
            label = "Mount"
        else:
            ( retval, message ) = mount_cd( "-m", device )
            label = "Unmount"
        if retval:
            err_diag = p2p_diag.P2PMessageDialog( None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_CANCEL, message )
            err_diag.run()
            err_diag.destroy()
        else:
            widget.set_label( label )

    def response_cb( self, widget, response ):
        if response == gtk.RESPONSE_CLOSE:
            self.hide()
        elif response == gtk.RESPONSE_DELETE_EVENT:
            self.hide()

    def delete_cb( self, widget, *args ):
        widget.hide()
        return 1
 

def mount_cd( action, path ):
    if action == "-m":
        cmd = "/bin/mount %s 2>&1" % path
    else:
        cmd = "/bin/umount %s 2>&1" % path
    fp = os.popen( cmd, "r" );
    lines = fp.readlines()
    retval = fp.close()
    if retval:
        err_str = "".join( lines )
        return ( retval, err_str )
    else:
        return ( 0, "" )

