#!/usr/bin/python

"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

import fstab

TESTS = ("Test CD/DVD Drive", "tgtest_cdrom", False),

def tgtest_cdrom():
    """runs tests to ensure the cdrom drives listed in the fstab are usable
    and that CD or DVD drives are going to be detected by winex
    this MUST use the same detection routines as in the winex sources"""

    ourfstab = fstab.fstab()
    res = []
    for cdrom in ourfstab.getCdromList():
        if cdrom.isCDDeviceReadable(): isRead = True
        else: isRead = False
        if cdrom.isCDDeviceWriteable(): isWrite = True
        else: isWrite = False
        if (isRead):
            useable = "Available"
            colour = "green"
#        elif (isRead):
        else:
            useable = "Available, but no Copy Protection"
            colour = "yellow"
#        else:
#            useable = "Not available"
#            colour = "red"
        res.append(('cdrom: ' + cdrom.getDev(), useable, colour))
    return res

def tgtest_cdrom_description():
    return 'This test locates all available CD-ROM\ndevices on your computer that will ' + \
           'be accessible\nby WineX.  It also determines if these devices\nare capable' + \
           'of supporting Copy Protected\ngames.\n\n' + \
           'This test should only take a few secounds\nat the most.\n\n' + \
           'If this test fails, consult the WineX\ndocumentation for more information.'

if (__name__ == "__main__"):
    for test in TESTS:
        print "running test ", test[0]
        eval(test[1] + '()')

