#!/usr/bin/python

"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

import wave
import ossaudiodev
import os, os.path

TESTS = ("Test For Sound Support", "tgtest_sound", False),

def tgtest_sound():
    """runs a test to ensure that sound output is working"""

    try:
        try:
            P2PPATH=os.environ["P2PPATH"] + "/"
        except:
            P2PPATH=""
        TestSound1 = wave.open(P2PPATH+'tests/testsound1.wav', 'rb')
        numframesleft = TestSound1.getnframes()
    except:
        return (('Basic sound test', "unable to open sound file,\ncan't test sound card", 'red'),)
    try:
        audio_out = ossaudiodev.open('/dev/dsp', 'w')
    except IOError, e:
        return (('Basic sound test', 'unable to open /dev/dsp', 'red'),)

    try:
        audio_out.setparameters(TestSound1.getframerate(), 16,
                                TestSound1.getnchannels(), ossaudiodev.AFMT_S16_LE, False)
                                #FIXME: use getsampwidth for 16 and AFMT_S16_LE
    except:
        audio_out.close()
        return (('Basic sound test', 'unable to play sound, your sound card may not be configured correctly', 'red'),)

    try:
        audio_out.reset()
        while numframesleft > 0:
            buffer = TestSound1.readframes(1000)
            audio_out.write(buffer)
            numframesleft -= 1000
    except:
        audio_out.close
        return (('Basic sound test', 'test failed part way through', 'red'),)

    audio_out.close()
    return (('Basic sound test', 'completed successfully,\ndid you hear the sound?', 'green'),)

def tgtest_sound_description():
    return 'This test attempts to play a sound file,\nat 44 khz. This test uses the same method\nas ' + \
           'WineX to play sound (OSS audio device).\nThis is by no means a comprehensive\naudio test, ' + \
           'though if you are able to hear\nthe sound you should at least have basic\nsound support in ' + \
           'WineX.\n\n' + \
           'This test should only take a few secounds,\nduring which you should hear a sound play.\n\n' \
           'If this test fails, consult your\nLinux distribution documentation.'


if (__name__ == "__main__"):
    for test in TESTS:
        print "running test ", test[0]
        print eval(test[1] + '()')

