"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

import ClientCookie, urllib

LOGINURL="http://www.transgaming.com/loginuser.php"
VERSION_URL="http://www.transgaming.com/versions.php"

LOGIN_OK=0
LOGIN_FAILED=-1
CONNECT_FAILED=-2

class winexGetError(Exception):
    def __init__(self, message):
        self.message = message

    def __str__(self):
        return self.message

def login_transgaming( username, password ):
    fp = ClientCookie.urlopen( LOGINURL, urllib.urlencode( { "fuser_name": username, "fpassword": password } ) )
    for line in fp.readlines():
        if line.find( "Login Failed!" ) != -1:
            raise winexGetError("Sorry your login attempt failed.  Please check your username and password.  If you continue to have difficulties please contact support@transgaming.com.")

def winex_versions():
    fp = ClientCookie.urlopen(VERSION_URL)
    versions = []
    for line in fp.readlines():
        (ver, bin_lic, bin, doc_lic, doc ) = line.strip().split(",")
        versions.append( { "version": ver, "binary_license": bin_lic, "binary": bin, "documentation_license": doc_lic, "documentation": doc } )
    return versions

def winex_get( version_list, version ):
    for ver in version_list:
        if ver["version"] == version:
            fp = ClientCookie.urlopen( ver["binary"] )
            return fp
    return None

def winex_get_license( P2P, version_list, version ):
    for ver in version_list:
        if ver["version"] == version:
            if len( ver["binary_license"] ):
                return ClientCookie.urlopen( ver["binary_license"] )
    return None
